import React, { useEffect } from "react";
import { Modal, Spin } from "antd";
import { useModalState } from "../../../../zustand/Modal";
import FormikForm from "../../../../Layout/Dashboard/FormikFormModel";
import ModelBody from "./Add";
import { getInitialValues, getValidationSchemaADD } from "./formUtil";
import { ModalEnum } from "../../../../enums/Model";
import { useObjectToEdit } from "../../../../zustand/ObjectToEditState";
import { useParams } from "react-router-dom";
import { useGetStudent } from "../../../../api/student";
import { Student } from "../../../../types/Item";
import { useAddPayment } from "../../../../api/payment";
import { useTranslation } from "react-i18next";

const ModalForm: React.FC = () => {
  const { isOpen, setIsOpen } = useModalState((state) => state);
  const { mutate, isSuccess, isLoading } = useAddPayment();
  const { set_object_to_edit, object_to_edit } = useObjectToEdit();
  useEffect(() => {
    if (isSuccess) {
      setIsOpen("isSuccess");
      set_object_to_edit({});
    }
  }, [setIsOpen, isSuccess, set_object_to_edit]);

  const { student_id } = useParams();
  const { data } = useGetStudent({
    show: student_id,
  });
  const student = data?.data as Student;

  const handleSubmit = (values: any) => {
    const dataToSend = {
      ...values,
      date: "",
      registration_record_id: student?.registration_record_id,
    };
    dataToSend["date"] = values?.date?.format("YYYY-MM-DD");
    set_object_to_edit(values);
    mutate(dataToSend);
  };

  const handleCancel = () => {
    setIsOpen("");
    set_object_to_edit({});
  };

  const [t] = useTranslation();
  return (
    <>
      <Modal
        className="ModalForm"
        centered
        width={"60vw"}
        footer={null}
        open={isOpen === ModalEnum?.PAYMENT_ADD}
        onCancel={handleCancel}
      >
        <FormikForm
          handleSubmit={handleSubmit}
          initialValues={getInitialValues(object_to_edit)}
          validationSchema={getValidationSchemaADD}
        >
          <header>
            {" "}
            {t("practical.add")} {t("models.payment")}{" "}
          </header>
          <main className="main_modal w-100">
            <ModelBody />
            <div className="buttons">
              <div onClick={handleCancel}>{t("practical.back")}</div>
              <button disabled={isLoading} type="submit">
                {t("practical.add")}

                {isLoading && (
                  <span className="Spinier_Div">
                    <Spin />
                  </span>
                )}
              </button>
            </div>
          </main>
        </FormikForm>
      </Modal>
    </>
  );
};

export default ModalForm;
